/* ===================================================================
 * LoginForm.java
 * 
 * Created Oct 4, 2004 12:32:26 PM
 * 
 * Copyright (c) 2004 Matt Magoffin (spamsqr@msqr.us)
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of 
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 
 * 02111-1307 USA
 * ===================================================================
 * $Id: LogonForm.java 4 2009-05-01 03:27:53Z msqr $
 * ===================================================================
 */

package magoffin.matt.ieat.web;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import magoffin.matt.ieat.AuthorizationException;
import magoffin.matt.ieat.domain.User;
import magoffin.matt.ieat.util.LogonCommand;

import org.springframework.validation.BindException;
import org.springframework.web.servlet.ModelAndView;

/**
 * Form controller for logging into the application.
 * 
 * @author Matt Magoffin (spamsqr@msqr.us)
 * @version $Revision: 4 $ $Date: 2009-05-01 15:27:53 +1200 (Fri, 01 May 2009) $
 */

public class LogonForm extends AbstractEatForm {
	
	@Override
	protected ModelAndView onSubmit(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws Exception {
		WebUtil.clearUserSessionData(request);
		LogonCommand form = (LogonCommand)command;
		ModelAndView result = null;
		try {
			User user = userBiz.logonUser(form.getLogin(),form.getPassword());
			WebUtil.saveUserSessionData(request,getDomainObjectFactory(),user);
			if ( webHelper.getSavedRequestURL(request) != null ) {
				String savedUrl = webHelper.getSavedRequestURL(request);
				WebUtil.clearSavedRequestURL(request);
				response.sendRedirect(savedUrl);
				return null;
			}
			result = new ModelAndView(getSuccessView());
		} catch ( AuthorizationException e ) {
			if ( e.getReason() == AuthorizationException.REGISTRATION_NOT_CONFIRMED ) {
				errors.reject("error.logon.pending", "Registration confirmation pending");
			} else {
				errors.reject("error.logon.auth", "Authorization error.");
			}
			result = showForm(request,response,errors);
		}
		return result;
	}
}
